registerDay(39,
{
	"title" : "Decorating The Board",
	"desc" : "Welcome back to another day here!<br>"
		+ " After reintroducing the basic concepts of the game yesterday, let's continue on a larger slightly fancier board with more mines than yesterday.<br><br>"
		+ " For today we will also take a look at some more advanced tricks to solving the board, that are likely not immediately obvious to a new player."
		+ " These mainly revolve around asking what configurations of mines are possible. This may lead to discovering that only one configuration is possible in which case we can progress."
		+ " Or it may be the case that we discover a tile, that contains a mine in every possible configuration or even better we discover a tile which is safe in every configuration."
		+ " In such situations we will be able to progress even without figuring out the exact locations of all mines quite yet.<br><br>"
		+ " So I went ahead and started a game, but I didn't go for the easy spots. Instead I have picked some more interesting spots to share and analyze.<br><br>"
		+ "<center><img src=\"desc/39_121.png\"/></center><br>"
		+ " First let's look at the well known 1-2-1 pattern. The 2 has three closed tiles next to it (A, B and C). So one of them is safe and two are mines."
		+ " Lets assume that A is safe, then B and C are mines. But there is a 1 below the 2 which counts both B and C, thus if B and C are mines we arrive at a contradiction."
		+ " In a similar manner if C is safe, then A and B would have to be mines and thus we would run into a contradiction with the 1 above the 2 which would count both A and B."
		+ " Finally if B is safe, then the mines are on A and C and now everything works out. The 1 above only counts A and the 1 below only counts C."
		+ " We can thus conclude that A and C are mines, while B is safe.<br><br>"
		+ "<center><img src=\"desc/39_Edge11.png\"/></center><br>"
		+ " In this example we are at the top edge of the board. The 1 next to A indicated that there is a mine either on A or on B. Which one is it? We don't know. But we don't need to know this anyways."
		+ " The 1 next to B, indicates that there is a mine below either A, B or C. So if the mine is on A then B and C are safe and if the mine is on B then A and C are safe."
		+ " So in either case we can conclude that C is safe. Or alternatively if there was a mine on C, then A and B would be safe, which contradicts the 1 next to A."
		+ " Despite us still not knowing where the mine is, we can still progress by leftclicking on C as that is safe either way.<br><br>"
		+ "<center><img src=\"desc/39_12.png\"/></center><br>"
		+ " And now for one more example here we have a 1 (above B) and a 2 (above C) next to each other against a flat wall. From just these we can't figure out all the tiles, but we can still make some progress."
		+ " From the 2 we know that out of B, C and D, two tiles contain a mine, while on is safe. Similar to the 1-2-1 pattern we can ask which of these could be the safe tile."
		+ " We will find that B or C could be safe. If D was safe then B and C would contain mines and that would contradict the 1. We have thus figured out that D has to contain a mine."
		+ " Plus since we know that either B or C contain a mine, this fully covers the 1 and as a result A must be safe.<br><br>"
		+ " There are more situations that you can solve in such a manner, but this is where I will leave it for today. Many other situations can be approached in an analogous way.",
	"mines" : {
		"R" : 60,
	},
	"grayMines" : true,
	"display" : "default",
	"decrementing" : false,
	"x" : 23,
	"y" : 23,
	"board" : "+y4U5oNQoSWAa0VHWxCaGhaliXRUGQsLoqCIWGaGBKwi1ChhSQjviEoWJaAAKFg8/0AA4Adsxp8BSrYYxIpu2IrCJ27CnIEtrX1KqWhLnsaIYAmPBC9d8cz9/5PsbA",


});
