registerDay(41,
{
	"title" : "Large Mines",
	"desc" : "Hey, remember how I promised a large surprise for today in yesterdays description?<br>"
		+ " Well here we are and when I said LARGE surprise, that was meant very literal.<br>"
		+ " Introducing: <b>Large Mines</b><br><br>"
		+ " While regular mines can only be seen from the neighboring tiles in a 3 by 3 area centered around the mine. Large mines can be seen from all the way in a 5 by 5 area centered around the mine.<br><br>"
		+ "<center><img src=\"desc/41_SmallAndLarge.png\"/></center><br>"
		+ " When you find a large mine you can rightclick twice to place a large flag."
		+ " However, often you may not know if you are dealing with a regular mine or with a large mine."
		+ " This will break a lot of the regular logic we used on the last three days, so if you encounter such familiar situations, ask yourself if this still works as before or if the pattern could be explained in a different manner with large mines."
		+ " So let's look at some examples how the game logic works once there are large mines in the mix.<br><br>"
		+ "<center><img src=\"desc/41_Simple.png\"/></center><br>"
		+ " In this image I already went ahead and flagged a few normal mines. These were easy to solve with standard logic. Large mines are counted in a well large area, thus it is easy to see that large mines simply would not have fit into any of these spots, leaving only normal mines.<br><br>"
		+ "<center><img src=\"desc/41_5Wide.png\"/></center><br>"
		+ " In this second example, it is easy to see that A, C, D, E and F can't contain a large mine. But is there a large mine on B or is this just the result of normal mines?"
		+ " Let's try and see where we would end up without a large mine. Well the two corners are easy and we would find mines on D and F."
		+ " But now the 1 below the E would have two mines around it, so we arrive at a contradiction."
		+ " Focusing on only the bottom left 1, there would have to be either some mine on D or a large one on A, B or E."
		+ " As A, D and E can't have a large mine and there can't be a normal mine on A either, the only valid option is for there to be a large mine below B."
		+ " And with that we have just found our very first large mine!<br><br>"
		+ "<center><img src=\"desc/41_Corner_1.png\"/></center><br>"
		+ " A 1 on a corner is still a fairly common thing that you may encounter. So what do we do here?"
		+ " There could be a normal mine on A, though that 1 could also be caused by a large mine on B. The tiles with an X can't contain a large mine as one would not fit there."
		+ " And there is of course also the option that there are normal mines on both A and B.<br>"
		+ " Which one of these is it? We don't know!<br>"
		+ " Fortunately we don't need to know in order to make progress.<br><br>"
		+ "<center><img src=\"desc/41_CuttingIntoTheCorner.png\"/></center><br>"
		+ " Here we first focus on the 1 two tiles above the corner. Weather there is a normal mine on A, a large mine on B or normal mines on A and B, this 1 is satisfied."
		+ " Meaning that the tiles with blue dots must be safe. Additionally we can also rule out additional large mines in the outer area, but we still couldn't click those as there may still be normal mines there."
		+ " Using a similar logic on the 1 outlined in green, we can also deduce that the tiles with a green dot must be safe.<br><br>"
		+ "<center><img src=\"desc/41_CuttingIntoTheCorner2.png\"/></center><br>"
		+ " Now we have uncovered quite a few more tiles, especially interesting is the 1 that touches both A and B. This rules out the possibility of normal mines on both A and B."
		+ " Like before we now also have two new 1s which are satisfied no matter if there is a small mine on A or a large mine on B. Leading to all the dotted tiles being confirmed safe.<br>"
		+ "If we were to mentally remove the one mine (whichever one it is) from the tiles effected in both cases."
		+ " We end up with the highlighted 1 at a corner again and thus all the logic we did with A and B can now also be used on C and D.<br>"
		+ " There are some more tricks for large mines, but this is where I'll leave you for today. Maybe you can even figure some of these tricks out by yourself.<br><br>"
		+ "<center><img src=\"desc/41_WrongFlags.png\"/></center><br>"
		+ "Desipte your best efforts you still lost a game. Here there are some new flag textures which I'd like to briefly explain."
		+ " You have probably already encountered one of these <img src=\"images/Flag_Wrong_R_0.png\"> which you get when you put a flag on a tile that didn't contain a mine and then loose."
		+ " I hope that this is more intuitive then a crossed out mine like in Minesweeper and might be better at showing your progress than the 2018 advent calendar which just removed all your correct flags."
		+ " Technically there now is this variant <img src=\"images/Flag_Wrong_RX_0.png\"> for placing a large flag when the tile was safe, but more importantly there are the cases where you mark a mine with an incorrect size."
		+ " <img src=\"images/Flag_Wrong_RX_R.png\"> is what happens when you put down a large flag for a small mine and <img src=\"images/Flag_Wrong_R_RX.png\"> is the result of placing a regular flag on a large mine.<br><br>"
		+ "Just one final note:<br>"
		+ "Yesterday I mentioned that I'd acknowledge adjusted mine probabilities for anything fancy. Well today is one of those cases."
		+ " There is a band going around the outside of the board with a largely reduced mine probability. This is so that mines will predominantly generate in the central region of the board."
		+ " Allowing you to tackle the board from all sides, instead of forcing you to work your way outwards, which is much more difficult with large mines.",
	"mines" : {
		"R" : 30,
		"RX" : 10,
	},
	"grayMines" : true,
	"display" : "default",
	"decrementing" : false,
	"x" : 27,
	"y" : 27,
	"board" : "/VENW8Ho0yt4ZoAJ9NA1VACjIYmoFpqJvkBVPDnXAYjDDz/0HAL5Ab5AAP6NDl8w58gUG/WsAfIBoeAI0DgB4YI0CQjRoA0XB0dBKAAqNA2hAcgAjoAAIyAIAA7t/788uY395DO+fD3ikm47N5d+nXMqIL3AgnDaHRFDzDQg8XU6YqpVoB5pMFvKv2UMu5je7t/yeA",
});
