(function(){

let gridAccumulate = function(name, accName){
	for(let i = 2; i < board.y; i++){
		board.at(0, i)[accName] = "";
	}
	for(let i = 2; i < board.x; i++){
		board.at(i, 0)[accName] = "";
	}
	for(let i = 2; i < board.x; i++){
		for(let j = 2; j < board.y; j++){
			let tile = board.at(i, j);
			if(tile == null) continue;
			board.at(i, 0)[accName] += tile[name];
			board.at(0, j)[accName] += tile[name];
		}
	}
};

let day42open = function(x, y){
	setFlag(x, y, "");
	board.at(x, y).open = true;
};

registerDay(42,
{
	"title" : "An Answer Loosely Related To Everything",
	"desc" : "What should one do for number 42?<br>"
		+ " I guess I can't just give you an answer to everything and tell you where all the mines are. That wouldn't make for a fun game."
		+ " So how about I just tell you where the mines are without giving you the exact locations."
		+ " For today all mines are in the square part of the board, but they are at a higher density then I would usually put them on a board like this."
		+ " However, there is also an additional strip at the top and at the left. No mines generate on there and once you start the game those tiles are immediately opened."
		+ " What they do is accumulate the mines in each row and column. So now as you play the main board, you may run into situations that couldn't be solved with regular logic, but can instead be solved through the remaining mine count on each row and column."
		+ " You may also end up discovering that you have already found all the mines in a row or column, meaning all the other tiles on it are safe.<br><br>"
		+ "And to avoid having to add up all the flags on each row/column, I'm bringing back the decrementing system from Minesveeper Zero."
		+ " If you are not familiar with that, what it does is subtract the number of surrounding flags from each tile."
		+ " So if you see a positive number that's how many mines there are still remaining. If you see a zero you have placed the correct amount of flags."
		+ " Although you are not guaranteed that those are in the correct positions."
		+ " With this it can become far easier to spot variants of the 1-2-1 or 1-2-2-1 pattern when there are other mines around that you have already found previously.<br><br>"
		+ " And finally if you see a negative number, you did something wrong and placed too many flags.<br><br>"
		+ " PS: I only made negative numbers down to -12 if you go further into the negatives you just get a <img src=\"images/No_Image.png\"> texture.",
	"mines" : {
		"R" : 90,
	},
	"grayMines" : true,
	"display" : "default",
	"shape" : "default",
	"decrementing" : true,
	"x" : 22,
	"y" : 22,
	"board" : "6K/74zs/0AEIAaACaACIA/LfJgg",
	"postFlagFunction" : function(tile, x, y){
		gridAccumulate("flag", "surroundingFlags");
	},
	"postGenFunction" : function(tile, x, y){
		for(let i = 0; i < board.x; i++){
			day42open(i, 0);
		}
		for(let i = 1; i < board.y; i++){
			day42open(0, i);
		}
		gridAccumulate("mine", "surroundingMines");
	},
});

})();
