registerDay(57, 
{
	"title" : "Redshift",
	"desc" : "Redshift, but there are only blue mines?<br>"
		+ "Exactly that's how their color can get redshifted.<br>"
		+ " While this board might not look too different to many of the previous ones, the truth is that this board is a bit larger in fact it is a lot larger, like at a universal scale large."
		+ " With the tiles being millions of light years apart."
		+ " And as space expands in that universe the wavelength of the light emitting from the blue mines gets stretched first to green, then to red and then outside of the visible spectrum.<br><br>"
		+ " In a sense this day works similar to Minesveeper 49 where it isn't the mine that determines the color but the color is determined by where the mine is relative to the tile.<br><br>"
		+ "<center><img src=\"desc/57_Redshift.png\"/></center><br>"
		+ "<center><img src=\"desc/57_Chromodynamics.png\" style=\"max-width:90%\"/></center><br>"
		+ "If a mine is on one of the 4 directly neighboring tiles, it is still counted as a blue mine."
		+ " A mine one tile diagonally away from it however gets redshifted towards green and is counted as a green mine instead, and finally a mine two tiles away directly up, down, left or right is detected as a red mine."
		+ " Any mine further away leaves the visible spectrum and isn't counted.<br><br>"
		+ " As much as I would have liked to leave decrementing \"off\" and tell you that you just need to wait for a view million years for the information to travel between tiles, decrementing is certainly necessary to reasonably play this variant.<br><br>"
		+ " This day has quite a high mine density as it gives you a lot of information, but as this also leads to some potentially small starting areas let's look at an example:<br><br>"
		+ "<center><img src=\"desc/57_RS1.png\"/></center><br>"
		+ "Here we got a pretty much minimal initial opening, and for none of tiles we can determine all of its mines immediately."
		+ " But there are still some numbers we can partially solve. First off, with colorcharge there is always the problem of mines canceling out. But what would it take for this to happen?"
		+ " Well there would have to be a mine in each of the 3 regions, so if for a number at least one of these regions is already fully solved, then there is no way that colors could cancel out."
		+ " With this let's look at the red 2, it would count A, C and E as red, while counting B and D as green, since there are no tiles that contribute as blue to the mine, it must be the result of just 2 mines somewhere on A, C or E."
		+ " This has the side effect that there can't be a mine contributing as green on B or D. So we found two safe tiles.<br>"
		+ " Next let's analyze the greenish yellow √3 there can't be a mine counted as blue as those tiles are safe."
		+ " It thus is the result of two green and one red. While we don't know where the mine counted as red is, we only have E and F that would count as green and they must thus be mines."
		+ " In fact this logic would even work if there where additional tiles contributing as blue, as we would then say that this √3 has at least two tiles counted as green and with there only being two such tiles it must be them. Which additionally then implies that there is no way for 3 other mines to cancel out.<br><br>"
		+ "<center><img src=\"desc/57_RS2.png\"/></center><br>"
		+ " We made a bit of progress and now the board looks like this. Here there are further places we can solve."
		+ " The blue 1 above the A, must have at least one mine counted as blue. As A is the only such tile it is the one with the mine. While all tiles that that 1 would count as red or green must be safe."
		+ " The green 2 at the top needs at least two mines diagonally from itself. Those must thus be on B and C. With all diagonal tiles solved, the tile above which would count as blue and the 3 tiles which would contribute red must be safe.<br><br>"
		+ "Note that the zero we see in this image is not yet confirmed to be solved. It still has two tiles each that would be counted as red, green and blue. There is still the chance of mines canceling out there, so don't doubleclick it quite yet.",
	"mines" : {
		"B" : 140,
	},
	"grayMines" : true,
	"display" : "colorcharge",
	"shape" : "default",
	"decrementing" : true,
	"x" : 27,
	"y" : 27,
	"board" : "+f6ABKAAepIKqIfRMERo5wAoAAoWAdGQ1Gi2jIevgSVP0GInzCbpgqoBOqwOjQZToJQ4I7BgjEhdYwdbQ3bIOcYKoyEo2E+9oMlAXRAKTQJ0JCUbDaMiDvg/fsGTUWv2Do0H7uD7/iVaxloRlBAExyFqrodVN19lsUcDwpM7zrkXL13xz9/4r1Byzwx2301abYZ",
	"shape" : {
		"small" : [
			// Distance 1 -> Red
			[0, 1, "b"], [0, -1, "b"], [1, 0, "b"], [-1, 0, "b"],
			// Distance Sqrt(2) -> Green
			[-1, -1, "g"], [-1, 1, "g"], [1, -1, "g"], [1, 1, "g"],
			// Distance 2 -> Blue
			[0, 2, "r"], [0, -2, "r"], [2, 0, "r"], [-2, 0, "r"],
		],
		"large" : surroundings["default"].large,
	},
	"xwrap" : 1,
	"ywrap" : 1,
});
