(function(){

let openedOnce = false;

day59Fnct = ()=>{
	if(!openedOnce){
		openedOnce = true;
		return 59;
	}else{
		return (Math.random() < 0.25) ? 59.5 : 59;
	}
};

registerDay(59,
{
	"title" : "Anti Knight",
	"desc" : "We are getting close to Christmas.<br>"
		+ "But that doesn't mean it's too late to introduce some new mechanics."
		+ " Remember how we had days where a mine would be counted as different colors based on the tile."
		+ " Today we are doing this once more, but without colorcharge. Here a mine is counted in the usual manner on the surrounding 8 tiles."
		+ " However, it is subtracted from the tiles which are knights path away.<br><br>"
		+ "<center><img src=\"desc/59_AntiKnight.png\"/></center><br>"
		+ "Now while this does of course once again allow for mines to cancel out, if you solve all surrounding 8 tiles and reach the required number, then the tiles knights path away are safe."
		+ " If a 1 only has one tile in the normal neighborhood, then that must be the mine while the tiles knights path away are safe."
		+ " The other way around of course works too, but those situations are a bit less common and are harder to spot."
		+ " Again, double clicking is your friend and will do the counting for you.<br><br>"
		+ " Anyways, I hope that you enjoy and that I'll see you again tomorrow.<br><br>"
		+ "PS: I had initially planned something else for today and even though I liked the other setting, unfortunately there was an issue with it, so I ended up replacing it with this one."
		+ " Guess the other one will just be lost...",
	"mines" : {
		"R" : 50,
	},
	"grayMines" : true,
	"display" : "minusgb",
	"decrementing" : false,
	"x" : 22,
	"y" : 22,
	"board" : "P8",
	"shape" : {
		"small" : [
			[0, 1], [0, -1], [1, 0], [-1, 0],
			[-1, -1], [-1, 1], [1, -1], [1, 1],
			[-2, -1, "g"], [-2, 1, "g"], [-1, -2, "g"], [-1, 2, "g"],
			[1, -2, "g"], [1, 2, "g"], [2, -1, "g"], [2, 1, "g"],
		],
		"large" : surroundings["default"].large,
	},
	"xwrap" : 0,
	"ywrap" : 0,
});

let gOnly = { R: "", G: "G", B: ""};
let bOnly = { R: "", G: "", B: "B"};

registerDay(59.5,
{
	"title" : "Small And Tall And Wide",
	"desc" : "Hey, you glitched into the secret Minesveeper 59.5 variant.<br>"
		+ "This was the one I had initially planned as Minesveeper 59, before I ended up replacing it."
		+ " But since I still liked this one I kept it in here as a secret you may randomly stumble across when selecting Minesveeper 59."
		+ " Why did I replace it? I'll get to that in a bit, for now let's look at this setting.<br><br>"
		+ " This is where we finally use large green mines in a Minesveeper game. Although here the large mines aren't as large as previously.<br><br>"
		+ "<center><img src=\"desc/59_SmallTallWide.png\"/></center><br>"
		+ "The normal red mines behave as usual, nothing weird here."
		+ " The large green mines function as our tall mines. They aren't counted in a 5 by 5 range but are instead counted in an area 5 tall and 3 wide centered around the mine."
		+ " Finally the large blue mines function as our wide mines they are counted in an area 3 tiles tall and 5 tiles wide, again centered around the mine.<br><br>"
		+ "<center><img src=\"desc/46_Colorcharge.png\" style=\"max-width:90%\"/></center><br>"
		+ " So what's the problem?<br>"
		+ " This is actually quite reasonably playable, <b>UNTIL</b> you overthink it just a tiny bit too much."
		+ " The problem with these mines is that a green mine could be above or below a red mine, with a blue mine simultaneously to the left or right of that red mine."
		+ " Even if this pattern doesn't actually occur it means that many of your clicks will have to be guesses (which are most likely safe, but are not guaranteed)."
		+ " I spent a while trying to figure out how this day could be adjusted to avoid this issue."
		+ " Though nothing I was particularly happy with. So I ended up replacing it with Anti Knight, which I had previously considered for the extension."
		+ " But then this felt unfair to this setting, so now it is here as a secret Minesveeper 59.5.<br><br>"
		+ " My advice for this one: Just accept the (most likely safe) guesses!",
	"mines" : {
		"R" : 24,
		"GX" : 12,
		"BX" : 12,
	},
	"grayMines" : false,
	"display" : "colorcharge",
	"decrementing" : false,
	"x" : 22,
	"y" : 22,
	"board" : "6Khl+gF/g/ABAASf6AAfQ1kXYRocCIqNb/pqnkVjBNFYNnRauJ780jA",
	"shape" : {
		"small" : [
			[0, 1], [0, -1], [1, 0], [-1, 0],
			[-1, -1], [-1, 1], [1, -1], [1, 1],
		],
		"large" : [
			[0, 1], [0, -1], [1, 0], [-1, 0],
			[-1, -1], [-1, 1], [1, -1], [1, 1],
			[-1, -2, gOnly], [0, -2, gOnly], [1, -2, gOnly], 
			[-1, 2, gOnly], [0, 2, gOnly], [1, 2, gOnly], 
			[-2, -1, bOnly], [-2, 0, bOnly], [-2, 1, bOnly], 
			[2, -1, bOnly], [2, 0, bOnly], [2, 1, bOnly], 
		],
	},
	"xwrap" : 1,
	"ywrap" : 2,
});

})();
