(function(){

let numbers = [
	Textures.closed.clear,
	Textures.closed.flags.B,
	Textures.closed.flags.G,
	Textures.closed.flags.R,
	Textures.closed.flags.BX,
	Textures.closed.flags.GX,
	Textures.closed.flags.RX,
	Textures.fnct.load("Flag_2.png"),
	Textures.fnct.load("Flag_3.png"),
];

let numbersSolved = [
	Textures.fnct.load("Flag_Final_0.png"),
	Textures.closed.finalFlags.B,
	Textures.closed.finalFlags.G,
	Textures.closed.finalFlags.R,
	Textures.closed.finalFlags.BX,
	Textures.closed.finalFlags.GX,
	Textures.closed.finalFlags.RX,
	Textures.fnct.load("Flag_Final_2.png"),
	Textures.fnct.load("Flag_Final_3.png"),
];

let mine = Textures.fnct.load("Closed_Explosion.png");

let defaultDraw = (tile, draw) => {
	if(tile.open){
		let n = tile.surroundingMines.length;
		if(n in numbers){
			draw(numbers[n]);
		}else{
			draw(Textures.invalid);
		}
	}else{
		if(tile.flag == ""){
			draw(Textures.background.clear);
		}else{
			let n = 0;
			if("unumber" in tile) n = tile.unumber;
			draw(Textures.background.number[n]);
		}
	}
};

registerDay(63, 
{
	"title" : "Unsolving",
	"alt-title" : "The One Deliberately Made To Mess With Zettex's Max Attainable Number Chart",
	"desc" : "Oh a clear board, you're done already!<br>"
	 	+ " With a time of 0:00.000, great job that's an unbeatable World Record and you can leave this day behind!<br>"
		+ " Well not quite, some things may be backwards today and I have replaced some textures."
		+ " Closed tiles are now open tiles and open tiles are now closed tiles. Flags have been replaced with numbers and numbers have been replaced with flags."
		+ "<ul>"
		+ "<li>1s are now Blue Flags"
		+ "<li>2s are now Green Flags"
		+ "<li>3s are now Red Flags"
		+ "<li>4s are now Large Blue Flags"
		+ "<li>5s are now Large Green Flags"
		+ "<li>6s are now Large Red Flags"
		+ "<li>Finally I still need a 7 and 8. I just brought back double and triple flags for those."
		+ "</ul>"
		+ "<center><img src=\"desc/63_Substitutions.png\"/></center><br>"
		+ " And of course leftclick now places and removes numbers while rightclick undigs open tiles.",
	"mines" : {
		"R" : 70,
	},
	"grayMines" : true,
	"display" : "default",
	"shape" : "default",
	"decrementing" : false,
	"confusion" : true,
	"x" : 20,
	"y" : 20,
	"board" : "P8",
	"renderFunction" : (tile, count, draw) => {
		count.open = "Uhh...";
		count.r = "What?"
		switch(gamestate){
			case "dead":
				if(tile.mine == "" || tile.flag != ""){
					defaultDraw(tile, draw);
				}else{
					draw(mine);
				}
				break;
			case "complete":
				if(tile.open){
					let n = tile.surroundingMines.length;
					if(n in numbersSolved){
						draw(numbersSolved[n]);
					}else{
						draw(Textures.invalid);
					}
				}else{
					let n = 0;
					if("unumber" in tile) n = tile.unumber;
					draw(Textures.background.number[n]);
				}
				break;
			default:
				defaultDraw(tile, draw);
				break;
		}
	},
	"postGenFunction" : (t, x_, y_) => {
		for(let x = 0; x < board.x; x++){
			for(let y = 0; y < board.y; y++){
				let t = board.at(x, y);
				if(t == null) continue;
				t["unumber"] = 0;
				for(let d of shape.small){
					let t2 = board.at(x + d[0], y + d[1]);
					if(t2 == null) continue;
					if(t2.mine != "") continue;
					let n = t2.surroundingMines.length;
					switch(n){
						case 1:
						case 2:
						case 3:
							t.unumber += 1;
							break;
						case 7:
							t.unumber += 1;
							break;
						case 8:
							t.unumber += 1;
							break;
					}
				}
				for(let d of shape.large){
					let t2 = board.at(x + d[0], y + d[1]);
					if(t2 == null) continue;
					if(t2.mine != "") continue;
					let n = t2.surroundingMines.length;
					switch(n){
						case 4:
						case 5:
						case 6:
							t.unumber += 1;
							break;
					}
				}
			}
		}
	},
});

})();
