(function(){

Textures.background.pow2icons = {
	"arrow_green" : Textures.fnct.load("misc/Arrow.png"),
	"arrow_gray" : Textures.fnct.load("misc/Arrow_Gray.png"),
	"questionmark_gray" : Textures.fnct.load("misc/Questionmark_Gray.png"),
};

let dogEffect = (x, y, on) => {
	t = board.at(x, y);
	t.effect = on ? "grayscale" : "";
	t.surroundingMines = accumulateSurrounding(x, y, "mine");
	t.surroundingFlags = accumulateSurrounding(x, y, "flag");
	if(on && t.surroundingMines == 0 && t.open && t.mine == "") openSurrounding(x, y);
};

let effectAll = (on) => {
	for(let x = 0; x < board.x; x++){
		for(let y = 0; y < board.y; y++){
			let t = board.at(x, y);
			if(t == null) continue;
			if(t.twoTile) dogEffect(x, y, on);
		}
	}
};

registerDay(64, 
{
	"title" : "The Power Of Two",
	"desc" : "The Power Of Two!<br>"
		+ " But what is the Power Of Two?<br><br>"
		+ " While today could be played like a regular day with some normal and large mines, there is a bit more to it."
		+ " Every 2 that appears on the board has a special power, which will give you a bit more information than just the 2 surrounding mines."
		+ " You can rightclick every 2 to turn it into a grayscale tile, these work just like they do when playing with the dog."
		+ " Counting only the 8 surrounding tiles, while counting large mines double."
		+ " Rightclicking one of these grayscale tiles, will turn it back into a normal two."
		+ " In addition as clicking every two on the board might get a bit tedious, I've added two buttons at the top left and right of the board."
		+ " Clicking (left or right) the one on the right will turn all 2s two grayscale tiles and clicking the left one will turn all those grayscale tiles back to normal 2s.",
	"mines" : {
		"R" : 20,
		"RX" : 20,
	},
	"grayMines" : true,
	"display" : "default",
	"shape" : "default",
	"decrementing" : false,
	"x" : 26,
	"y" : 22,
	"button1" : [0, 0],
	"button2" : [24, 0],
	"specialNumber" : 2,
	"board" : "8VpVEBL8AeiokloBRX/SsQ0ADj/oqIJSAdFQBAAzRUTfFapWIoqTAAf5T8NY9yUDEsFV6fc7cZT4",
	"postGenFunction" : (t, x_, y_) => {
		for(let x = 0; x < board.x; x++){
			for(let y = 0; y < board.y; y++){
				let t = board.at(x, y);
				if(t == null) continue;
				let isTwo = false;
				if(activeSettings.display == "colorcharge"){
					let r = 0;
					let g = 0;
					let b = 0;
					for(let a of t.surroundingMines.toLowerCase()){
						if(a == "r") r++;
						if(a == "g") g++;
						if(a == "b") b++;
					}
					let m = Math.min(r, g, b);
					r -= m;
					g -= m;
					b -= m;
					if((r == 0 && g == 0) || (r == 0 && b == 0) || (g == 0 && b == 0) || (r == 0 && g == b) || (g == 0 && r == b) || (b == 0 && r == g)){
						isTwo = Math.max(r, g, b) == activeSettings.specialNumber;
					}
				}else if(activeSettings.display == "minusgb"){
					let n = 0;
					for(let a of t.surroundingMines.toLowerCase()){
						if(a == "r") n++;
						if(a == "g") n--;
						if(a == "b") n--;
					}
					isTwo = n == activeSettings.specialNumber;
				}else{
					isTwo = t.surroundingMines.length == activeSettings.specialNumber;
				}
				t.twoTile = isTwo;
			}
		}
		let b1 = activeSettings.button1;
		let b2 = activeSettings.button2;
		let button = board.at(b1[0], b1[1]);
		if(button != null) button.surroundingMines = ["background", "pow2icons", "arrow_green"];
		button = board.at(b1[0] + 1, b1[1]);
		if(button != null) button.surroundingMines = ["background", "number", "2"];
		button = board.at(b2[0], b2[1]);
		if(button != null) button.surroundingMines = ["background", "pow2icons", "arrow_gray"];
		button = board.at(b2[0] + 1, b2[1]);
		if(button != null) button.surroundingMines = ["background", "pow2icons", "questionmark_gray"];
	},
	"entityEvents" : function(x, y, ev){
		let b1 = activeSettings.button1;
		let b2 = activeSettings.button2;
		if(ev == Entities.events.startGame){
			let button = board.at(b1[0], b1[1]);
			if(button != null) button.open = true;
			button = board.at(b1[0] + 1, b1[1]);
			if(button != null) button.open = true;
			button = board.at(b2[0], b2[1]);
			if(button != null) button.open = true;
			button = board.at(b2[0] + 1, b2[1]);
			if(button != null) button.open = true;
			return;
		}
		if(y == b1[1] && (x == b1[0] || x == b1[0] + 1)){
			// Remove effect to all
			effectAll(false);
			return;
		}
		if(y == b2[1] && (x == b2[0] || x == b2[0] + 1)){
			// Add effect to all
			effectAll(true);
			return;
		}
		if(ev != Entities.events.voidClickR) return;
		let t = board.at(x, y);
		if(t == null) return;
		if(!t.twoTile) return;
		if(t.effect == "grayscale"){
			dogEffect(x, y, false);
		}else{
			dogEffect(x, y, true);
		}
	},
});

})();
