(function(){

Textures.background.clocks = {
	"1" : Textures.fnct.load("misc/Clock_1.png"),
	"2" : Textures.fnct.load("misc/Clock_2.png"),
	"3" : Textures.fnct.load("misc/Clock_3.png"),
	"4" : Textures.fnct.load("misc/Clock_4.png"),
};

registerDay(65, 
{
	"title" : "Late Measurements",
	"desc" : "Welcome Back!<br>"
		+ " Today serves as the counterpart to Minesveeper 47. There you only saw numbers the first turn after uncovering them. Now you will need a few turns before you get the number."
		+ " When you open a tile each number that would appear is replaced with a clock."
		+ " Whenever you dig another tile each clock counts down and when they reach zero the number will be revealed.<br><br>"
		+ "<center><img src=\"desc/65_Clock.png\"/></center><br>"
		+ " Note that the eye laches above the board are always safe so if you need to stall for a turn, that's how you can do it."
		+ " Especially since in order to play this without guessing you will need four of them before you even get the first numbers."
		+ " While testing I was usually able to complete the board without having to rely on additional turns to stall the game.",
	"mines" : {
		"R" : 65,
	},
	"grayMines" : true,
	"display" : "default",
	"shape" : "default",
	"decrementing" : false,
	"x" : 31,
	"y" : 25,
	"xwrap" : 1,
	"board" : "/RkKRgWo0AJgE6whq/BFMApZQTokDo4BQAQAG0sBkYFJ/oAD+jAG94JTEJekJ0xFljEpgOqCdMA5ywWsIYzATowDOeEUxEH2APowMswF1lDnrBNYRFfg2i4QswB35GkYF7KkTjhWjAmywBTIPdMDwBoaEX0A6khL/gE4qMCtAAVAAMovviCTjzMw0IMAEYcQVpvzDPue7H3HeSTQ/R0t+vpRWquim6/LLYo4IZvTyS7t/fbA",
	"postGenFunction" : (t, x_, y_) => {
		for(let x = 0; x < board.x; x++){
			for(let y = 0; y < board.y; y++){
				let t = board.at(x, y);
				if(t == null) continue;
				t.clockVisible = false;
				if(t.surroundingMines != ""){
					t.surroundingMines = ["background", "clocks", "4"];
				}
			}
		}
	},
	"preDigFunction" : () => {
		for(let x = 0; x < board.x; x++){
			for(let y = 0; y < board.y; y++){
				let t = board.at(x, y);
				if(t == null) continue;
				if(t.open && typeof(t.surroundingMines) == "object") t.clockVisible = true;
			}
		}
	},
	"entityEvents" : function(x_, y_, ev) {
		if(ev != Entities.events.digOrChord) return;
		for(let x = 0; x < board.x; x++){
			for(let y = 0; y < board.y; y++){
				let t = board.at(x, y);
				if(t == null) continue;
				if(t.clockVisible){
					t.clockVisible = false;
					let n = +t.surroundingMines[2];
					if(n == 1){
						t.surroundingMines = accumulateSurrounding(x, y, "mine");
					}else{
						t.surroundingMines[2] = "" + (n - 1);
					}
				}
			}
		}
	},
});

})();
