(function(){

Textures.background.clickIcon = {
	"1" : Textures.fnct.load("misc/Click_1.png"),
	"2" : Textures.fnct.load("misc/Click_2.png"),
	"3" : Textures.fnct.load("misc/Click_3.png"),
};

Textures.background.letter = Textures.fnct.load("misc/Letter.png");

let htmlLetters = {
	"$geneva" : "<b>No Crosses</b><br><br>Today I made sure that this board does not violate the Geneva convention. What do I mean by this? Mines on this board are usually marked in red."
	+ " So if there is a mine with another mines above, below to it's left and to it's right, then that could be seen as a <b>Red Cross</b> and thus one may come to the conclusion, that today violates the Geneva convention."
	+ " But don't worry I made sure that no such pattern appears. This includes situations where 5 such mines are part of a larger structure too.<br><br>"
	+ "<center><img src=\"desc/68_NoCross.png\"></center><br>"
	+ "The first 3 patterns are examples that could not occur here, while the two on the right are perfectly fine.",
};

registerDay(68, 
{
	"title" : "Final Puzzle For Now",
	"desc" : "Welcome, to the final day of the extended advent calendar!<br>"
		+ " So for today I have set up a very specific puzzle. Everyone gets the exact same pattern everytime. However, this pattern can be solved without guessing."
		+ " Now in order to start you will have to click the marked tile at the top left, after that you should be able to solve this first try."
		+ " Oh, and if you mess up and click a mine the board will automatically reset, so while you will have learned that the tile in question is a mine you will not be shown the position of every mine.<br><br>"
		+ "<b>So what's next?</b><br>"
		+ " First off all I'll be taking a bit of a break from working on Minesveeper, which has consumed a lot of my time over the past months."
		+ " Instead I want to dedicate some time towards some of my other projects that have been neglected for a while.<br>"
		+ "With that aside I do have a few ideas for some future Minesveeper variants. The next Minesveeper should be 37 which got delayed so that I can finish the advent calendar in time."
		+ " Once that one is done I'll go back to continuing this series in order."
		+ " Though one thing I'll say right now: I will not be doing an advent calendar next year!<br><br>"
		+ " As of now I do not want to make any promisses on when any of those will release, so maybe join the <a href=\"https://discord.com/invite/ZqEXjqB\" class=\"buttonlink\">Discord Server</a> to stay up to date, or check back here every few months.<br><br>"
		+ "<b>But can I still add <em>&lt;???&gt;</em> ?</b><br>"
		+ "If you check the menu at the top, there is a Download Button now, anything you may want to try with this advent calendar that couldn't be done with the Day 61 editor you can now do by downloading the files and modifying them as you please.<br><br>"
		+ "So have fun and I'll hope to see you again when more Minesveeper Variants come out eventually.<br>"
		+ "Or maybe sooner on one of my other games on this website.",
	"mines" : {
		"R" : 20,
	},
	"grayMines" : true,
	"display" : "default",
	"shape" : "default",
	"decrementing" : false,
	"autoRestart" : true,
	"fixedPattern" : true,
	"setter" : [
		[5, 5, ["background", "clickIcon", "1"]],
		[6, 5, ["background", "clickIcon", "2"]],
		[7, 5, ["background", "clickIcon", "3"]],
		[14, 17, ["background", "pow2icons", "arrow_green"]],
		[16, 17, ["background", "number", "1"]]
	],
	"letters" : [
		[8, 5, "You found a letter!\n\nYou probably just learned that you can click on these, which you might want to do when you encounter one of these."],
		[2, 8, "So when did you find this?\n\nIf you are here rather late, then everything is fine.\nHowever, if you are here early on, then I have some words for you!\n"
		+"You may have clicked on this because if this tile was a mine, then there would be a guessing spot. Well I just want to warn you that there may be different ways to solve this."
		+" So perhaps this isn't the type of logic that you may want to rely on!"],
		[12, 5, "$geneva"],
		[13, 17, "A safe but dishonest line!\n\nAll of the 6 tiles on this row to the right of this letter are safe.\nHowever: One of the numbers you will see there is a lie. Which one that is, is up to you to figure out!"],
		[14, 19, "Fourfold Foundation!\n\nYou have found the lowest letter on the board. Perhaps now is a good time to take a look at the very bottom of the board. So what makes up the lowest row of the board. Well first of all there is this letter, but telling you that might be a bit redundant. Well there are some numbers too, but perhaps most important will be the knowledge that the bottom row only contains a total of four mines.\n\nThis makes the bottom row, the row with the lowest number of mines, together with the second row from the top, but you probably already know about that one."],
		[19, 2, "Maximum Number!\n\nSometimes one may wonder what the maximum number possible on a given day is? Well today this is rather easy as the patten is always the same. The maximum number is therefor not just"
		+ " a hypothetical but will always appear. And this special number for today is 7. Despite normal mines allowing for 8s this particular board, does not contain one of those. Instead the highest number you will see"
		+ " will be a 7."],
		[3, 13, "First Below, Now Left\n\nBy now you probably know about the total amount of mines on the bottom row and with how far you progressed you should be able to clear the board soon!"
		+ " Yet, there is still one more guessing spot that needs to be resolved.\n"
		+ "But why would I put a guessing spot on here?\n"
		+ "You see there is a strategy that some people use for no guess games, where they conclude that if a tile was a mine, then there would be a 50/50 guessing spot and thus the tile can be assumed to be safe."
		+ " Though with letters giving you hints instead, such a strategy might be dangerous, so early on in this board I put such a spot as bait."
		+ " Once that tile would be clicked there's a letter calling out the player for this strategy.\n\n"
		+ "Now this leaves us with a guessing spot and like before with the bottom row, I think it is now time for you to learn that the left most column contains a total of exactly 8 mines!"]
	],
	"x" : 20,
	"y" : 20,
	"board": "++IQvoPTICX4H29AXWArfA7+Amf9AQEQegAGhwHQAARQB0DAABoUAoIA/csHaALpkELgEacBSUA1vgNpwbs2CocE3pB1+BtdQhnAy4oG7gN6mBCRA9RgJBgbQAGQ0Ho+EJGDdfgJWQSsoOu4DriBrYA13CFIB3URa3FPvMsNta6b7Y4Z5e+f/c8d9SyTzQwRxW2X3U0V1FIo5ggGJA",
	"entityEvents" : function(x, y, ev){
		if(ev == Entities.events.startGame){
			for(let l of activeSettings.letters){
				let t = board.at(l[0], l[1]);
				if(t != null) t.surroundingMines = ["background", "letter"];
			}
			return;
		}
		if((ev != Entities.events.voidClickL) && (ev != Entities.events.voidClickR)) return;
		for(let l of activeSettings.letters){
			if(l[0] == x && l[1] == y){
				if(l[2].startsWith("$")){
					openWarning(htmlLetters[l[2]]);
				}else{
					openWarning("");
					let warningContent = document.getElementById("warning-content");
					let t = l[2].split("\n");
					for(let i = 0; i < t.length; i++){
						if(i != 0){
							warningContent.appendChild(document.createElement("br"));
						}
						let s = document.createElement((i > 0) ? "span" : "b");
						s.innerText = t[i];
						warningContent.appendChild(s);
					}
				}
			}
		}
	},
});


// Unlock the download page
let downloadPage = document.getElementById("description-download");
day68Fnct = {
	open: ()=>{
		revealElement(downloadPage);
		pageSections.titleDay.innerHTML = "Download Minesveeper";
	},
	close: ()=>{
		hideElement(downloadPage);
	},
};

let dlImage = document.getElementById("dl-image");
dlImage.src = "images/misc/Download_Black.png";
let dlButton = document.getElementById("dayButton_DL");
dlButton.className = "daybutton_active";
dlButton.onclick = function() {
	setMenu(4);
	stopGame();
};

console.log(days[68].board);

})();
